/**************************
 * Includes
 *
 **************************/

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "resource.h"

/**************************
 * Function Declarations
 *
 **************************/

LRESULT CALLBACK WndProc (HWND hWnd, UINT message,
WPARAM wParam, LPARAM lParam);
void EnableOpenGL (HWND hWnd, HDC *hDC, HGLRC *hRC);
void DisableOpenGL (HWND hWnd, HDC hDC, HGLRC hRC);


/**************************
 * WinMain
 *
 **************************/

int WINAPI WinMain (HINSTANCE hInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpCmdLine,
                    int iCmdShow)
{
 WNDCLASS wc;
 HWND hWnd;
 HDC hDC;
 HGLRC hRC;        
 MSG msg;
 BOOL bQuit = FALSE;

 //   ,    
 float theta = 25.0f, d = 0.01f;


 //  

 //      :
 float square=1.0f;
 //  :
 float x=0.0f, z=0.0f;
 //   :
 float y1=1.25f, y2=0.15f, y3=0.0f, y4=0.5f;


 /* register window class */
 wc.style = CS_OWNDC;
 wc.lpfnWndProc = WndProc;
 wc.cbClsExtra = 0;
 wc.cbWndExtra = 0;
 wc.hInstance = hInstance;
 wc.hIcon = LoadIcon (hInstance, MAKEINTRESOURCE (ID_PIC));
 wc.hCursor = LoadCursor (NULL, IDC_ARROW);
 wc.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH);
 wc.lpszMenuName = NULL;
 wc.lpszClassName = "GLSample";
 RegisterClass (&wc);

 int cx, cy;

 cx=(LONG)::GetSystemMetrics (SM_CXSCREEN);
 cy=(LONG)::GetSystemMetrics (SM_CYSCREEN);

 hWnd = CreateWindowEx (
  0,// Extended possibilites for variation
  "GLSample", "OpenGL Sample",
  WS_POPUP,
  -1,// CW_USEDEFAULT Windows decides the position
  -1,// CW_USEDEFAULT where the window ends up on the screen
  cx+2,// The programs width
  cy+2,// and height in pixels
  HWND_DESKTOP,// The window is a child-window to desktop
  NULL,// No menu
  hInstance,// Program Instance handler
  NULL// No Window Creation data
 );

 ShowWindow (hWnd, iCmdShow);

 /* enable OpenGL for the window */
 EnableOpenGL (hWnd, &hDC, &hRC);

 glShadeModel (GL_SMOOTH);//   
 glViewport (0, 0, cx+2, cy+2);
 glMatrixMode (GL_PROJECTION);
 gluPerspective (45.0f, (GLfloat)cx/(GLfloat)cy, 0.1f, 100.0f);

 glClearDepth (1.0);      // Depth Buffer Setup
 glEnable (GL_DEPTH_TEST);// Enables Depth Testing
 glDepthFunc (GL_LEQUAL); // The Type Of Depth Testing To Do

 glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
 glMatrixMode (GL_MODELVIEW);

 ShowCursor (false);

 /* program main loop */
 while (!bQuit)
 {
  /* check for messages */
  if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
  {
   /* handle or dispatch messages */
   if (msg.message == WM_QUIT)
    bQuit = TRUE;
   else
   {
    TranslateMessage (&msg);
    DispatchMessage (&msg);
   }
  }
  else
  {
   // 1- 

   //     :
   float r=sqrt (pow (square, 2)+pow (square, 2));
   //       :
   float r1=sqrt (pow ((-square-x), 2)+pow ((-square-z), 2)),
         r2=sqrt (pow ((-square-x), 2)+pow ((square-z), 2)),
         r3=sqrt (pow ((square-x), 2)+pow ((square-z), 2)),
         r4=sqrt (pow ((square-x), 2)+pow ((-square-z), 2));

   //      ( ,   )
   //     ,   :
   float h=(y1*(r*2-r1)/r/4.0f+y2*(r*2-r2)/r/4.0f+y3*(r*2-r3)/r/4.0f+y4*(r*2-r4)/r/4.0f);


   // 2- 

   float min, mx;
   float z0, x0, h0, h1, h2;

   //         ,
   //            :
   if (y1>y2)
   {
    mx=y1;
    min=y2;
    z0=square-z;
   }
   else
   {
    mx=y2;
    min=y1;
    z0=square+z;
   }

   //        
   h0=mx-min;
   //  ,
   float angle=atan (h0/(square*2));
   //             ;
   //      :
   h1=tan (angle)*z0+min;
   //     atan/tan:
   h1=h0/(square*2)*z0+min;

   //     :
   if (y4>y3)
   {
    mx=y4;
    min=y3;
    z0=square-z;
   }
   else
   {
    mx=y3;
    min=y4;
    z0=square+z;
   }

   h0=mx-min;
   h2=h0/(square*2)*z0+min;

   //          :
   if (h1>h2)
   {
    mx=h1;
    min=h2;
    x0=square-x;
   }
   else
   {
    mx=h2;
    min=h1;
    x0=square+x;
   }

   h0=mx-min;
   //   -    :
   h=h0/(square*2)*x0+min;


   //  2- 
   h1=y1*(square*2-(square+z))/(square*2.0f)+y2*(square*2-(square-z))/(square*2.0f);
   h2=y4*(square*2-(square+z))/(square*2.0f)+y3*(square*2-(square-z))/(square*2.0f);
   h=h1*(square*2-(square+x))/(square*2.0f)+h2*(square*2-(square-x))/(square*2.0f);


   /* OpenGL animation code goes here */
   glClearColor (0.0f, 0.0f, 0.0f, 0.0f);
   glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   glPushMatrix ();

   glLoadIdentity();
   glTranslatef (0.0f, -0.5f, -3.5f);
   glRotatef (10, 1.0f, 0.0f, 0.0f);
   glRotatef (theta, 0.0f, 1.0f, 0.0f);
   glBegin (GL_QUADS);

   glNormal3f (0.0f, 1.0f, 0.0f);//   
   glColor3f (1.0f, 0.0f, 0.0f); glVertex3f (-square, y1, -square);//  
   glColor3f (0.0f, 1.0f, 0.0f); glVertex3f (-square, y2,  square);//  
   glColor3f (0.0f, 0.0f, 1.0f); glVertex3f ( square, y3,  square);//  
   glColor3f (0.0f, 0.0f, 0.5f); glVertex3f ( square, y4, -square);//  

   glColor3f (1.0f, 1.0f, 1.0f);
   glVertex3f (-0.15f+x, 0.5f+h, 0.0f+z);
   glVertex3f (0.15f+x, 0.5f+h, 0.0f+z);
   glVertex3f (0.15f+x, 0.0f+h, 0.0f+z);
   glVertex3f (-0.15f+x, 0.0f+h, 0.0f+z);

   glColor3f (0.5f, 0.5f, 0.5f);
   glVertex3f (0.0f+x, 0.5f+h, -0.15f+z);
   glVertex3f (0.0f+x, 0.5f+h, 0.15f+z);
   glVertex3f (0.0f+x, 0.0f+h, 0.15f+z);
   glVertex3f (0.0f+x, 0.0f+h, -0.15f+z);

   glEnd ();
   glPopMatrix ();

   SwapBuffers (hDC);

   x+=d;
   z+=d;
   if ((x>square || z>square) || (x<-square || z<-square))
   {
    d*=-1;
    x+=d;
    z+=d;
   }
   theta += 0.5f;
   if (theta>360.0f)
    theta-=360.0f;

   Sleep (1);
  }
 }

 /* shutdown OpenGL */
 DisableOpenGL (hWnd, hDC, hRC);

 /* destroy the window explicitly */
 DestroyWindow (hWnd);

 return msg.wParam;
}


/********************
 * Window Procedure
 *
 ********************/

LRESULT CALLBACK WndProc (HWND hWnd, UINT message,
                          WPARAM wParam, LPARAM lParam)
{
 switch (message)
 {
  case WM_CREATE:
   return 0;

  case WM_CLOSE:
   PostQuitMessage (0);
   return 0;

  case WM_DESTROY:
   return 0;

  case WM_KEYDOWN:
   PostQuitMessage(0);
   return 0;

  default:
   return DefWindowProc (hWnd, message, wParam, lParam);
 }
}


/*******************
 * Enable OpenGL
 *
 *******************/

void EnableOpenGL (HWND hWnd, HDC *hDC, HGLRC *hRC)
{
 PIXELFORMATDESCRIPTOR pfd;
 int iFormat;

 /* get the device context (DC) */
 *hDC = GetDC (hWnd);

 /* set the pixel format for the DC */
 ZeroMemory (&pfd, sizeof (pfd));
 pfd.nSize = sizeof (pfd);
 pfd.nVersion = 1;
 pfd.dwFlags = PFD_DRAW_TO_WINDOW | 
  PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
 pfd.iPixelType = PFD_TYPE_RGBA;
 pfd.cColorBits = 24;
 pfd.cDepthBits = 16;
 pfd.iLayerType = PFD_MAIN_PLANE;
 iFormat = ChoosePixelFormat (*hDC, &pfd);
 SetPixelFormat (*hDC, iFormat, &pfd);

 /* create and enable the render context (RC) */
 *hRC = wglCreateContext( *hDC );
  wglMakeCurrent( *hDC, *hRC );
}


/******************
 * Disable OpenGL
 *
 ******************/

void DisableOpenGL (HWND hWnd, HDC hDC, HGLRC hRC)
{
 wglMakeCurrent (NULL, NULL);
 wglDeleteContext (hRC);
 ReleaseDC (hWnd, hDC);
}
